unit umain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ExtCtrls, simpleipc;

type

  { TForm1 }

  TForm1 = class(TForm)
    ed_server_ID: TEdit;
    ed_instance_ID: TEdit;
    btn_serveractive: TSpeedButton;
    ed_data: TLabeledEdit;
    lbl_server_ID: TLabel;
    lbl_instance_ID: TLabel;
    tmr_poll: TTimer;
    procedure btn_serveractiveClick(Sender: TObject);
    procedure DoOnNewData(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tmr_pollTimer(Sender: TObject);
  private
    { private declarations }
    FRunning: Boolean;
    FServer: TSimpleIPCServer;
    procedure _StartServer;
    procedure _StopServer;
    procedure _Poll;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btn_serveractiveClick(Sender: TObject);
begin
  if btn_serveractive.Down then begin
    // start server
    _StartServer;
  end
  else begin
    // stop server
    _StopServer;
  end;
end;

procedure TForm1.DoOnNewData(Sender: TObject);
begin
  writeln('got new data');
  ed_data.Text := ed_data.Text + FServer.StringMessage;
  if FServer.StringMessage = 'c' then ed_data.Text:='';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FRunning:=false;
  FServer := TSimpleIPCServer.Create(Self);
  Self.Caption := 'SERVER';
  FServer.OnMessage:=@DoOnNewData;
  FServer.Global:=true;
  FServer.ServerID:='simple';
  ed_server_ID.Text:=FServer.ServerID;
  ed_server_ID.Enabled:=false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FServer.Free;
end;

procedure TForm1.tmr_pollTimer(Sender: TObject);
var
  vReceived: Boolean;
begin
  tmr_poll.Enabled := false;
  writeln('poll...');
  repeat
    vReceived := FServer.PeekMessage(10, true);
    Application.ProcessMessages;
  until not vReceived;
  writeln('received = ', BoolToStr(vReceived, true));
  tmr_poll.Enabled := true;
end;

procedure TForm1._StartServer;
begin
  FServer.StartServer;
  ed_server_ID.Text   := FServer.ServerID;
  ed_instance_ID.Text := FServer.InstanceID;
  writeln('active = ',BoolToStr(FServer.Active, true));
  _Poll;
end;

procedure TForm1._StopServer;
begin
  tmr_poll.Enabled := false;
  FServer.StopServer;
  FRunning:=false;
  ed_server_ID.Text   := '';
  ed_instance_ID.Text := '';
  writeln('active = ',BoolToStr(FServer.Active, true));
end;

procedure TForm1._Poll;

begin
  FRunning:=true;
  tmr_poll.Interval:=1000;
  tmr_poll.Enabled:=true;
end;

end.

